/*
 * (c) Copyright 2002 - 2004 -- Anders Torger
 *
 * This program is open source. For license terms, see the LICENSE file.
 *
 */
#ifndef _ELOG_H_
#define _ELOG_H_

#include <stdio.h>

#define elog(level, format, args...)                                           \
    if (global_loglevel >= (level)) {                                          \
        _elog(level, __FILE__, __FUNCTION__, __LINE__, format, ##args);        \
    }

#define LOGERROR 1
#define LOGINFO  2
#define LOGDEBUG 3

extern int global_loglevel;
extern FILE *elog_stream;

void
elog_init(const char log_path[]);

void
elog_concatenate_file(const char path[]);

void
elog_truncate(void);

int
elog_loglevel_get(void);

void
elog_loglevel_set(int loglevel);

void
elog_close(void);

void
_elog(int level,
      const char _file[],
      const char _function[],
      int _line,
      const char format[],
      ...);

#endif
