/*
 * (c) Copyright 2003 -- Anders Torger
 *
 * This program is open source. For license terms, see the LICENSE file.
 *
 */
#ifndef _EQUALISER_H_
#define _EQUALISER_H_

#include "almusvcu.h"
#include "idarray.h"
#include "filterprg.h"

extern bool_t equaliser_debug;

int
eq_sanitycheck(const struct vcu_eqpart eqparts[],
	       int n_parts,
	       const idarray_t *custom_prgs);

int
eq_generate(const struct vcu_eqpart eqparts[],
	    int n_parts,
	    const idarray_t *custom_prgs, /* may be NULL */
            const int block_sizes[],
	    const int rates[],
	    int n_rates,
            int realsize,
	    int delay[],
	    struct prepfilter *filter);

int
eq_properties(const struct prepfilter *filter,
              struct vcu_eqamp amp[VCU_FREQ_ISO_3OCT_BANDS],
              double *peak_amp);

void
eq_init(const char log_path[]);

/* exported low-level filter design functions below */
void *
eq_design_fft_filter(int *n_taps,
                     double sample_rate,
                     int block_size,
                     int n_bands,
                     const double bands[],
                     const double amps[],
                     int realsize);

void *
eq_design_whitenoise_filter(int *n_taps,
                            double sample_rate,
                            double length,
                            int realsize);


#endif
