/*
 * (c) Copyright 2002 -- Anders Torger
 *
 * This program is open source. For license terms, see the LICENSE file.
 *
 */
#ifndef _IDARRAY_H_
#define _IDARRAY_H_

#include "defs.h"

typedef struct _idarray_t_ idarray_t;

idarray_t *
idarray_new(bool_t packed);

idarray_t *
idarray_new_ex(bool_t packed,
	       void *values[],
	       int length,
	       bool_t allocate);

void
idarray_delete(idarray_t *idarray);

int
idarray_new_id(idarray_t *idarray,
	       void *value);

void *
idarray_delete_id(idarray_t *idarray,
		  int id);

int
idarray_length(const idarray_t *idarray);

void *
idarray_get(const idarray_t *idarray,
	    int id);

void *
idarray_next(const idarray_t *idarray,
	     int *id);

int
idarray_get_first_id(const idarray_t *idarray);

int
idarray_id2index(const idarray_t *idarray,
		 int id);

#endif
