/*
 * (c) Copyright 2002 - 2003 -- Anders Torger
 *
 * This program is open source. For license terms, see the LICENSE file.
 *
 */
#ifndef _KEYINPUT_H_
#define _KEYINPUT_H_

#include <sys/types.h>

#include "defs.h"

#define KI_KEY_FAILURE -2
#define KI_KEY_IGNORE -1

/* Required keys */
#define KI_KEY_UP 1
#define KI_KEY_DOWN 2
#define KI_KEY_LEFT 3
#define KI_KEY_RIGHT 4

/* Optional keys */
#define KI_KEY_OPTIONAL_BASE 5
#define KI_KEY_MVOL_UP 5
#define KI_KEY_MVOL_DOWN 6
#define KI_KEY_GVOL_UP 7
#define KI_KEY_GVOL_DOWN 8
#define KI_KEY_REVERB_PRG_NEXT 9
#define KI_KEY_CHANNEL_MODE_NEXT 10
#define KI_KEY_GROUP_NEXT 11
#define KI_KEY_EQ_MODE_NEXT 12
#define KI_KEY_MASTER_MUTE 13
#define KI_KEY_GROUP_MUTE 14
#define KI_KEY_MAX 14

struct keyinput {
    int (*init)(void);
    int (*getkey)(int fd,
		  int *repeats);
};

bool_t
keyinput_init(struct keyinput inputs[],
	      int n_inputs);

void
keyinput_setfds(fd_set *rfds);

int
keyinput_getkey(int fd,
                bool_t drop_queued);

void
keyinput_flush_queue(int fd);

#endif
