/*
 * (c) Copyright 2002 - 2003 -- Anders Torger
 *
 * This program is open source. For license terms, see the LICENSE file.
 *
 */
#ifndef _TEXTMENU_H_
#define _TEXTMENU_H_

#include "textgui.h"
#include "defs.h"

union textmenu_value {
    int *cyclic;
    int *integer;
    double *real;
    char *string;
    state_func_t substate;
};

struct textmenu_entry {
    char *str;
#define TEXTMENU_ENTRY_SUBSTATE 1
#define TEXTMENU_ENTRY_CYCLIC 2
#define TEXTMENU_ENTRY_REAL 3
#define TEXTMENU_ENTRY_INTEGER 4
#define TEXTMENU_ENTRY_ASK 5
#define TEXTMENU_ENTRY_NONE 6
#define TEXTMENU_ENTRY_STRING 7
    int type;
    union textmenu_value value;    
};

struct textmenu_state {
    char *heading;
    int pos;
    int n_entries;
    struct textmenu_entry *entries;
};

struct textmenu_state *
textmenu_state_new(const char heading[],
		   void *entries[]);

void
textmenu_state_delete(struct textmenu_state *state);

void
textmenu_action(struct textmenu_state *state,
		int *action);

void
textmenu_showpage(int *action,
		  int *pos,
		  const char *lines[],
		  int n_lines);

void
textmenu_yesno(bool_t *answer,
               const char line1[],
               const char line2[]);

#if 0
void
textmenu_warn(bool_t *answer,
	      const char warning[]);
#endif

void
textmenu_message(const char line1[],
		 const char line2[]);

#endif

